/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

2gU
3D\
GPGPU(lvZGPUŎsj

GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

#include <windows.h>
#include <math.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath6.h"
#include "../../myPrimitive6.h"
#include "../../support3D.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void rendering();
void setTexturePhi();
void setFramebufferPhi();
void drawNumberingPoints();
void renewPhi(float d);
void createFloor();

//͗pf[^̃TCY
int texWidth, texHeight;//Siq

//͗pf[^z
float *phi;
GLuint texID[1];//texture object
GLuint fbo[1];//frame buffer object

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum internalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RED;//RGBA;
GLenum type = GL_FLOAT;
//VF[_vO
GLuint shader1, shader2;

int floor0;//floordisplay list

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("GP_Diffusion2D");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ĕ`
	glutIdleFunc(idle);
	//ݒ
	glewInit();//framebuffer𗘗pƂɕKv
	init();
	initGlsl(&shader1, "simulation.vert", "simulation.frag");
	initGlsl(&shader2, "rendering.vert", "rendering.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
 	free(phi);
	glDeleteTextures(1, texID);
	glDeleteFramebuffersEXT(1, fbo);
	glDeleteProgram(shader1);
	glDeleteProgram(shader2);
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);
	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist= 25.0;
	view.vCnt = Vector3D(0.0, 0.0, 2.0);
	view.theta = 10.0;
	view.phi = -90.0;//-yOCE +x
	view.fovY = 20.0;
	view.nearZ =  0.1;
	view.farZ = 200.0;    	
	setCamera();
	view0 = view;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	glGenTextures(1, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(1, fbo);//t[obt@IuWFNg̐

	//\EBhEɕ_O鏀
	setFontBitmaps();

	initData();
	createFloor();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initData()
{
	flagFreeze = 0;
	flagStep = false;

	rect.delta.x = rect.size.x / (float)rect.nMesh;
	rect.delta.y = rect.size.y / (float)rect.nMesh;

	//ʃeNZTCY
	texWidth  = rect.nMesh + 1;//WeNX`̉TCY
	texHeight = texWidth;      //WeNX`̏cTCY
	//ʔz̐錾
	phi = (float*)malloc(texWidth * texHeight * sizeof(float));
	
	int i, j, k;
	float x, y, r;

	for(j = 0; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			k = i + j * texWidth;
			//`S̋
			x = (float)(i - texWidth / 2) * rect.delta.x ;
			y = (float)(j - texHeight / 2) * rect.delta.y;
			if(profile == 0)//Cylinder
			{
				r = sqrt(x * x + y * y);
				if(r < radiusInit) phi[k] = 1.0;//
				else phi[k] = 0.0;
			}
			else//Cube
			{
				if(fabs(x) < radiusInit && fabs(y) < radiusInit) phi[k] = 1.0;
				else phi[k] = 0.0;
			}
		}
	setTexturePhi();
	setFramebufferPhi();

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}

void setTexturePhi()
{
	glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, phi);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setFramebufferPhi()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[0] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	float deltaT = deltaT0 / (float)thinningN;
	float diff_num = diff_coef * deltaT / (rect.delta.x * rect.delta.x);//gU
	if(flagStart==true && flagFreeze == false)
	{
		//ʂ̍XV
		for(int i = 0; i < thinningN; i++) renewPhi( diff_num ); 

		if(flagStep) flagFreeze = true;
		elapseTime2 += deltaT;//dt;
	}

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	resize(win_width, win_height);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	rendering();
	
	glCallList(floor0);//En
	if(flagScaleShow) drawScale(10.0, 10.0, 5.0);
	if(flagCoordShow) drawWorldCoordinates(3.0);

	if(flagParamShow) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("timestep=%1.5f[s]", dt, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
		drawParam("deltaX=%f", rect.delta.x, 10, 60);
		drawParam("deltaT=%1.4f[s]", deltaT, 200, 60);
		drawParam("diff_num=%1.4f", diff_num, 400, 60);
	}
	//obt@̐؂ւ
	glutSwapBuffers();	
}

void renewPhi(float diff_num)
{
	//framebuffer object0L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[0] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//phi[]
	//VF[_vOL
	glUseProgram(shader1);
	GLint samplerPhiLoc = glGetUniformLocation(shader1, "samplerPhi");
	glUniform1i(samplerPhiLoc, 0);//GL_TEXTURE0Kp
	GLint texWidthLoc = glGetUniformLocation(shader1, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint diffLoc = glGetUniformLocation(shader1, "diff_num");
	glUniform1f(diffLoc, diff_num);
	GLint sizeLoc = glGetUniformLocation(shader1, "size0");
	glUniform1f(sizeLoc, rect.size.x);
	GLint boundaryLoc = glGetUniformLocation(shader1, "boundary");
	glUniform1i(boundaryLoc, boundary);

	drawNumberingPoints();//l͗peNZ\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, phi);
	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	if(flagConstant)
	{
		int i, j, k;
		float x, y, r;
		for(j = 0; j < texHeight; j++)
			for(i = 0; i < texWidth; i++)
			{
				k = i + j * texWidth;
				//`S̋
				x = (float)(i - texWidth / 2) * rect.delta.x ;
				y = (float)(j - texHeight / 2) * rect.delta.y;
				if(profile == 0)//Cylinder
				{
					r = sqrt(x * x + y * y);
					if(r < radiusInit) phi[k] = 1.0;//ʁixCZxetc.)
				}
				else//Cube
				{
					if(fabs(x) < radiusInit && fabs(y) < radiusInit) phi[k] = 1.0;//ʁixCZxetc.)
				}
			}
		setTexturePhi();
		setFramebufferPhi();
	}
}

void drawNumberingPoints()
{
	//r[|[g̃TCYݒ
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	//es̐ݒ
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	//ʂeNX`Ƃē\t邽߂̉zIuWFNg
	glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
	   glVertex2f((float)i, (float)j);//_W2iq_ԍ
	glEnd();
}

void rendering()
{
	glUseProgram(shader2);

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//phi[]

	GLint samplerPhiLoc = glGetUniformLocation(shader2, "samplerPhi");
	glUniform1i(samplerPhiLoc, 0);//GL_TEXTURE0Kp
	GLint texWidthLoc = glGetUniformLocation(shader2, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint nMeshLoc = glGetUniformLocation(shader2, "nMesh");
	glUniform1i(nMeshLoc, rect.nMesh);
	GLint sizeLoc = glGetUniformLocation(shader2, "size0");
	glUniform1f(sizeLoc, rect.size.x);
	GLint adjustHLoc = glGetUniformLocation(shader2, "adjustH");
	glUniform1f(adjustHLoc, adjustH);
	GLint colorLoc = glGetUniformLocation(shader2, "color");
	glUniform1i(colorLoc, color);

	if(flagWireframe == 0)
		drawGridPlate((float)rect.nMesh, (float)rect.nMesh, rect.nMesh, rect.nMesh);
	else
		drawGridLines((float)rect.nMesh, (float)rect.nMesh, rect.nMesh, rect.nMesh);

	glUseProgram(0);
}

void createFloor()
{
	floor0 = glGenLists(1);
	if(floor0 == 0) {printf("display list mۂł܂ł\n"); return;}
	glNewList(floor0, GL_COMPILE);
	glPushMatrix();
	glTranslatef(0.0, 0.0, -0.001);
	drawFloorZ(rect.size.x, rect.size.y, 2, 2);
	glPopMatrix();
	glEndList();
}
