/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

2FDM
QԂɂ镽s_Ng
Q͉~(Zpŋߎj
֐-Qx@
QxPoissonƉQx̗A݂ɌvZ

grid\ŋE̊iq_Ԃŕ\̂6p`ߎmF
*/
#include <windows.h>
#include <GL/glut.h>
#include <GL/glui.h>//GLUIgp
#include <math.h>
#include "../../support2D.h"
#include "../../myMath6.h"
#include "../../particle2D.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void idle();
void display();
void drawRegion();
void drawCylinder();
void resize(int w, int h);
void calculate(float dt);
void methodCIP(float deltaT);
void calcVelocity();
void drawContour(float PP[][NUM_MAX_Y], float minP, float maxP, Color color);
void drawVelocity();
void drawArrow();
void drawGrid();
Vector2D getVelocityParticle(Vector2D pos);
void drawParticle(float dt);

float Psi[NUM_MAX_X][NUM_MAX_Y];//֐
float Omega[NUM_MAX_X][NUM_MAX_Y];//Qx
float gx[NUM_MAX_X][NUM_MAX_Y];//x
float gy[NUM_MAX_X][NUM_MAX_Y];//y

Vector2D Vel[NUM_MAX_X][NUM_MAX_Y];//iq_̑x
Vector2D scale;//Window(-1.0, -1.0)ƂfJgWɕ\Ƃ̃XP[

float maxPsi0, minPsi0, maxOmg0, minOmg0;

enum Type{INSIDE, INLET, OUTLET, TOP, BOTTOM, OBSTACLE, OBS_LEFT, OBS_TOP, OBS_BOTTOM,
          OBS_RIGHT, OBS_UL, OBS_UR, OBS_LL, OBS_LR};
Type type[NUM_MAX_X][NUM_MAX_Y]; //iq_̃^Cv
int NX, NY;
float DX, DY;

Particle2D p[MAX_PARTICLE];
//bool flagResetting = false;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);

	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("GL_DuctCylinder");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);

	//ݒ
	init();
	setupGLUI();//myGLUI.hɎ

	GLUI_Master.set_glutIdleFunc( idle );
	//Cxg[vɓ
	glutMainLoop();
	return 0;
}
void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}


void init(void)
{
	//wiF
	glClearColor(1.0, 1.0, 1.0, 1.0);
	glEnable(GL_POINT_SMOOTH);
	//\EBhEɕ_O鏀
	setFontBitmaps();
	
	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	elapseTime2 = 0.0;//start̑oߎ
	elapseTime3 = 0.0;//start̑oߎ(j
	
	NX = rect.nMeshX;
	NY = rect.nMeshY;
	DX = rect.delta.x = rect.size.x / (float)NX;
	DY = rect.delta.y = rect.size.y / (float)NY;
	
	//TCY̊mF
	float eps = 0.00001;
	if( fabs((float)(int(rect.obs_left / DX )) * DX - rect.obs_left) > eps) { printf("~̒S_iq_ɈvĂȂ \n"); flagResetting = true;}
	if( fabs((float)(int(rect.obs_radius / DX)) * DX - rect.obs_radius) > eps) {printf("~̔aiq_Ԋu̐{ɈvĂȂ \n"); flagResetting = true;}
	if( fabs(DX - DY) > eps) {printf("iqԊusv \n"); flagResetting = true;}

	//iq_̃^Cv
	int i, j;
	eps = DX/2.0;
	float x, y, x1, x2, y1, y2, x0, y0, r, r0;
	x0 = rect.obs_left;//~̒S
	y0 = rect.size.y/2.0;
	r0 = rect.obs_radius;
	for(i = 0; i <= NX; i++)
		for(j = 0; j <= NY; j++)
		{
			type[i][j] = INSIDE;//_
			if(j == 0) type[i][j] = BOTTOM;//ǖ
			if(j == NY) type[i][j] = TOP;//㑤ǖ
			if(i == 0) type[i][j] = INLET;//[
			if(i == NX) type[i][j] = OUTLET;//o[
			x = (float)i * DX;
			y = (float)j * DY;
			if(y < y0 - r0 - DY) continue;
			if(y > y0 + r0 + DY) continue;
			if(x < x0 - r0 - DX) continue;
			if(x > x0 + r0 + DX) continue;

			r = sqrt((x - x0) * (x - x0) + (y - y0) * (y - y0));
			if(r > r0 + eps) continue;
			if( r <= r0 ) type[i][j] = OBSTACLE;//ł͋E܂

			if( fabs(y - y0 - r0) < eps ) type[i][j] = OBS_TOP;
			else if( fabs(y - y0 + r0) < eps ) type[i][j] = OBS_BOTTOM;
			else if( fabs(x - x0 + r0) < eps ) type[i][j] = OBS_LEFT;
			else if( fabs(x - x0 - r0) < eps ) type[i][j] = OBS_RIGHT;
			else
			{
				x1 = x0 - sqrt(r0 * r0 - (y - y0) * (y - y0));//_
				x2 = x0 + sqrt(r0 * r0 - (y - y0) * (y - y0));//E_
				y1 = y0 - sqrt(r0 * r0 - (x - x0) * (x - x0));//_
				y2 = y0 + sqrt(r0 * r0 - (x - x0) * (x - x0));//㑤_
				if(i == int(x1/DX + 0.5) && y > y0 ) type[i][j] = OBS_UL;//
				if(j == int(y2/DY + 0.5) && x < x0 ) type[i][j] = OBS_UL;//
				if(i == int(x1/DX + 0.5) && y < y0 ) type[i][j] = OBS_LL;//
				if(j == int(y1/DY + 0.5) && x < x0 ) type[i][j] = OBS_LL;//
				if(i == int(x2/DX + 0.5) && y > y0) type[i][j] = OBS_UR;//E
				if(j == int(y2/DY + 0.5) && x > x0) type[i][j] = OBS_UR;//E
				if(i == int(x2/DX + 0.5) && y < y0) type[i][j] = OBS_LR;//E
				if(j == int(y1/DY + 0.5) && x > x0) type[i][j] = OBS_LR;//E
			}
		}
		
	//l
	for (i = 0; i <= NX; i++)
		for(j = 0; j <= NY; j++)
		{
			//֐
			Psi[i][j] = (float)j * rect.delta.y;;
			//Qx
			Omega[i][j] = 0.0;
			//x
			Vel[i][j].x = 1.0;
			if(type[i][j] == BOTTOM || type[i][j] == TOP || type[i][j] >= OBSTACLE) Vel[i][j].x = 0.0;
			Vel[i][j].y = 0.0;
			gx[i][j] = 0.0;
			gy[i][j] = 0.0;
		}
	//EC
	//[/o͗1(psi = y)
	//̕ǂ psi = 0C̕ǂ psi = rect.size.y
	for (i = 0; i <= NX; i++)
		for(j = 0; j <= NY; j++)
		{
			if(type[i][j] == BOTTOM) Psi[i][j] = 0.0;
			else if(type[i][j] == TOP) Psi[i][j] = rect.size.y;
			else if(type[i][j] == INLET || type[i][j] == OUTLET) Psi[i][j] = (float)j * rect.delta.y;
			else if(type[i][j] >= OBS_LEFT) Psi[i][j] = rect.size.y / 2.0;//Q\
		}

	calcVelocity();

	maxPsi0 = -1000.0; minPsi0 = 1000.0;
	maxOmg0 = -1000.0; minOmg0 = 1000.0;

	countP = 0;
	for(i = 0; i < MAX_PARTICLE; i++) p[i] = Particle2D();

}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	float dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);
	//J[obt@̃NA
	glClear(GL_COLOR_BUFFER_BIT);

	//vZ̈`
	drawRegion();
	
	if(flagStart && !flagFreeze) 
	{ 
		elapseTime2 += dt;
		elapseTime3 += deltaT ;//
		calculate(deltaT); 
		
		if(flagStep) flagFreeze = true;
	}

	if( flagStream ) drawContour(Psi, minPsi, maxPsi, BLACK);
	if( flagVorticity ) drawContour(Omega, minOmg, maxOmg, RED);

	if( flagVelocity ) drawVelocity();
	//if( flagGrid ) drawGrid();

	if(flagP_Start) drawParticle(deltaT);//qAj[V

	drawCylinder();
	
	if( flagGrid ) drawGrid();

	//UȂ߂̖ڈm邽
	float Courant, diff_num;
	if(rect.delta.x < rect.delta.y)
	{
		Courant = deltaT / rect.delta.x;	
		diff_num = (1.0 / Re) * deltaT / (rect.delta.x * rect.delta.x);//gU
	}
	else
	{
		Courant = deltaT / rect.delta.y;	
		diff_num = (1.0 / Re) * deltaT / (rect.delta.x * rect.delta.y);//gU
	}

	if(flagParameter)
	{
		drawParam("f_rate=%d[fps]", fps0, -0.99, 0.9);
		drawParam("t_step=%2.5f[s]", dt, -0.6, 0.9);
		drawParam("e_time=%3.3f[s]", elapseTime2, -0.1, 0.9);
//		drawParam("deltaT=%6.2f", deltaT, 0.2, 0.9);
		drawParam("n_time=%3.3f", elapseTime3, 0.3, 0.9);
		drawParam("Courant=%1.4f", Courant, -0.99, 0.8);
		drawParam("diff_num=%1.4f", diff_num, -0.6, 0.8);
	}
	if(flagResetting) drawParam("Reset obstacle size",  -0.5, 0.0);
	//obt@̐؂ւ
	glutSwapBuffers();
}

void calculate(float deltaT)
{
	int i, j;
	float error = 0.0;
	float maxError = 0.0;
	float pp;
	float DX2 = DX * DX;
	float DY2 = DY * DY;
	float DD2 = DX2 + DY2;//corner

	//֐E
	for (j = 1; j < NY; j++) {
		//Psi[0][j] = (float)j * rect.delta.y;//Dirichlet(ȗj
		Psi[NX][j] = Psi[NX-1][j];//Neumann
	}

	//QxE
	float psi_obs = rect.size.y/2.0;
	for (i = 0; i <= NX; i++)
		for (j = 0; j <= NY; j++) 
		{
			if(type[i][j] == INSIDE) continue;
			else if(type[i][j] == INLET) Omega[i][j] = 0.0;//Dirichlet(j
			else if(type[i][j] == OUTLET) Omega[i][j] = Omega[i-1][j];//Neumannioj
			else if(type[i][j] == TOP) Omega[i][j] = -2.0 *( Psi[i][NY-1] - rect.size.y) / DY2;
			else if(type[i][j] == BOTTOM) Omega[i][j] = -2.0 * Psi[i][1] / DY2;
			else if(type[i][j] == OBS_LEFT) Omega[i][j] = -2.0 * (Psi[i-1][j] - psi_obs) / DX2;
			else if(type[i][j] == OBS_RIGHT) Omega[i][j] = -2.0 *( Psi[i+1][j] - psi_obs) / DX2;
			else if(type[i][j] == OBS_TOP) Omega[i][j] = -2.0 *( Psi[i][j+1] - psi_obs) / DY2;
			else if(type[i][j] == OBS_BOTTOM) Omega[i][j] = -2.0 * (Psi[i][j-1] - psi_obs) / DY2;
			else if(type[i][j] == OBS_UL) Omega[i][j] = -2.0 * (Psi[i-1][j+1] - psi_obs) / DD2;
			else if(type[i][j] == OBS_UR) Omega[i][j] = -2.0 * (Psi[i+1][j+1] - psi_obs) / DD2;
			else if(type[i][j] == OBS_LL) Omega[i][j] = -2.0 * (Psi[i-1][j-1] - psi_obs) / DD2;
			else if(type[i][j] == OBS_LR) Omega[i][j] = -2.0 * (Psi[i+1][j-1] - psi_obs) / DD2;
		}
	
	//Poisson̕
	int cnt = 0;
	while (cnt < iteration)
	{
		maxError = 0.0;

		for (i = 1; i < NX; i++)
			for (j = 1; j < NY; j++)
			{
				if(type[i][j] >= OBS_LEFT) continue;
				pp = ( DY2 * (Psi[i - 1][j] + Psi[i + 1][j]) + DX2 *(Psi[i][j - 1] + Psi[i][j + 1])
					 + Omega[i][j] * DX2 * DY2 ) / (2.0 * (DX2 + DY2));
				error = fabs(pp - Psi[i][j]);
				if (error > maxError) maxError = error;
				Psi[i][j] = pp;//XV
			}
		if (maxError < tolerance) break;
		cnt++;
	}

	//QxA
	methodCIP(deltaT);

	if(flagParameter)
	{
		drawParam("cnt=%d", cnt, -0.2, 0.8);
		drawParam("maxerror=%2.7f", maxError, 0.1, 0.8);
	}

	calcVelocity();

	//֐CQx̍ŏlCől
	for(i = 1; i < NX; i++)
		for (j = 1; j < NY; j++)
		{
			if(type[i][j] >= OBS_LEFT) continue;
			if(Psi[i][j] > maxPsi0) maxPsi0 = Psi[i][j];
			if(Psi[i][j] < minPsi0) minPsi0 = Psi[i][j];
			if(Omega[i][j] > maxOmg0) maxOmg0 = Omega[i][j];
			if(Omega[i][j] < minOmg0) minOmg0 = Omega[i][j];
		}

//printf("maxPsi=%f minPsi=%f \n", maxPsi0, minPsi0);
//printf("maxOmg=%f minOmg=%f \n", maxOmg0, minOmg0);
}

void calcVelocity()
{
	float DX = rect.delta.x;
	float DY = rect.delta.y;
	int i, j;
	//xxNǧvZ
	//iq_̑xxNg(㉺E̗֐̍ŋ߂)
	for(i = 1; i < NX; i++)
		for (j = 1; j < NY; j++)
		{
			if(type[i][j] >= OBS_LEFT) continue;
			//|eV̒Ⴂ獂
			Vel[i][j].x = (Psi[i][j+1] - Psi[i][j-1]) / (DY * 2.0);
			Vel[i][j].y = (Psi[i-1][j] - Psi[i+1][j]) / (DX * 2.0);
		}
}
void methodCIP(float deltaT)
{
	float newOmega[NUM_MAX_X][NUM_MAX_Y];//Qx
	float newGx[NUM_MAX_X][NUM_MAX_Y];//x
	float newGy[NUM_MAX_X][NUM_MAX_Y];//y

	float c11, c12, c21, c02, c30, c20, c03, a, b, sx, sy, x, y, dx, dx2, dx3, dy, dy2, dy3; 

	int i, j, ip, jp;
	for(j = 1; j < NY; j++)
		for(i = 1; i < NX; i++)
		{
			if(type[i][j] >= OBS_LEFT) continue;

			if(Vel[i][j].x >= 0.0) sx = 1.0; else sx = -1.0;
			if(Vel[i][j].y >= 0.0) sy = 1.0; else sy = -1.0;

			x = - Vel[i][j].x * deltaT;
			y = - Vel[i][j].y * deltaT;
			ip = i - (int)sx;//㗬_
			jp = j - (int)sy;
			dx = sx * rect.delta.x;
			dy = sy * rect.delta.y;
			dx2 = dx * dx;
			dx3 = dx2 * dx;
			dy2 = dy * dy;
			dy3 = dy2 * dy;

			c30 = ((gx[ip][j] + gx[i][j]) * dx - 2.0 * (Omega[i][j] - Omega[ip][j])) / dx3;
			c20 = (3.0 * (Omega[ip][j] - Omega[i][j]) + (gx[ip][j] + 2.0 * gx[i][j]) * dx) / dx2;
			c03 = ((gy[i][jp] + gy[i][j]) * dy - 2.0 * (Omega[i][j] - Omega[i][jp])) / dy3;
			c02 = (3.0 * (Omega[i][jp] - Omega[i][j]) + (gy[i][jp] + 2.0 * gy[i][j]) * dy) / dy2;
			a = Omega[i][j] - Omega[i][jp] - Omega[ip][j] + Omega[ip][jp];
			b = gy[ip][j] - gy[i][j];
			c12 = (-a - b * dy) / (dx * dy2);
			c21 = (-a - (gx[i][jp] - gx[i][j]) * dx) / (dx2*dy);
			c11 = - b / dx + c21 * dx;

			newOmega[i][j] = Omega[i][j] + ((c30 * x + c21 * y + c20) * x + c11 * y + gx[i][j]) * x
				        + ((c03 * y + c12 * x + c02) * y + gy[i][j]) * y;

			newGx[i][j] = gx[i][j] + (3.0 * c30 * x + 2.0 * (c21 * y + c20)) * x + (c12 * y + c11) * y;
			newGy[i][j] = gy[i][j] + (3.0 * c03 * y + 2.0 * (c12 * x + c02)) * y + (c21 * x + c11) * x;

			//Sɒ
			newOmega[i][j] += deltaT * ( (Omega[i-1][j] - 2.0 * Omega[i][j] + Omega[i+1][j]) / dx2
							 + (Omega[i][j-1] - 2.0 * Omega[i][j] + Omega[i][j+1]) / dy2 ) / Re;

		}
	//XV
	for(j = 1; j < NY; j++)
		for(i = 1; i < NX; i++)
		{
			if(type[i][j] >= OBS_LEFT) continue;
			Omega[i][j] = newOmega[i][j];
			gx[i][j] = newGx[i][j];
			gy[i][j] = newGy[i][j];
		}
			
}

void drawRegion()
{
	float s1, s2;
	if(win_width >= win_height) 
	{
	  s1 = win_ratio;
	  s2 = 1.0;
	}
	else
	{
	  s1 = 1.0;
	  s2 = 1.0 / win_ratio;
	}

	scale.x = 1.5 * rect.scale * s1 ;
	scale.y = 1.5 * rect.scale * s2 ;
	float sx = scale.x * rect.size.x / 2.0;
	float sy = scale.y * rect.size.y / 2.0;

	//_
	rect.left0.x = rect.pos0.x - sx;
	rect.left0.y = rect.pos0.y - sy;

	//S̘g
	glLineWidth(1.0);
	//F
	glColor3f(0.0, 0.0, 0.0);
	//[h
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glLineWidth(3.0);

	glBegin(GL_QUADS);
	glVertex2f(rect.left0.x, rect.left0.y); 
	glVertex2f(rect.left0.x + scale.x * rect.size.x, rect.left0.y);
	glVertex2f(rect.left0.x + scale.x * rect.size.x, rect.left0.y + scale.y * rect.size.y);
	glVertex2f(rect.left0.x, rect.left0.y + scale.y * rect.size.y); 
	glEnd();

	glLineWidth(3.0);
	glBegin(GL_LINES);
	//
	glVertex2f(rect.left0.x, rect.left0.y); 
	glVertex2f(rect.left0.x + scale.x * rect.size.x, rect.left0.y);
	//㑤
	glVertex2f(rect.left0.x, rect.left0.y + scale.y * rect.size.y); 
	glVertex2f(rect.left0.x + scale.x * rect.size.x, rect.left0.y + scale.y * rect.size.y);
	glEnd();

	drawCylinder();

}

void drawCylinder()
{
	int nn = 30;
	float theta0 = 2.0 * M_PI / (float)nn;
	Vector2D pos0, pos1, pos2;
	pos0 = Vector2D(rect.obs_left, rect.size.y/2.0);//~S

	glPolygonMode(GL_FRONT, GL_FILL);
	glColor3f(0.7, 0.8, 0.8);

	int i;
	for(i = 0; i < nn; i++)
	{
		pos1.x = rect.obs_radius * cos((float)i * theta0);
		pos1.y = rect.obs_radius * sin((float)i * theta0);
		pos2.x = rect.obs_radius * cos((float)(i+1) * theta0);
		pos2.y = rect.obs_radius * sin((float)(i+1) * theta0);
		pos1 += pos0;
		pos2 += pos0;
			
		glBegin(GL_TRIANGLES);
		glVertex2f(rect.left0.x + scale.x * pos0.x, rect.left0.y + scale.y * pos0.y);
		glVertex2f(rect.left0.x + scale.x * pos1.x, rect.left0.y + scale.y * pos1.y);
		glVertex2f(rect.left0.x + scale.x * pos2.x, rect.left0.y + scale.y * pos2.y);
		glEnd();
	}

	glPolygonMode(GL_FRONT, GL_LINE);
	glLineWidth(1.0);
	glColor3f(0.0, 0.0, 0.0);
	for(i = 0;i < nn; i++)
	{
		pos1.x = rect.obs_radius * cos((float)i * theta0);
		pos1.y = rect.obs_radius * sin((float)i * theta0);
		pos2.x = rect.obs_radius * cos((float)(i+1) * theta0);
		pos2.y = rect.obs_radius * sin((float)(i+1) * theta0);
		pos1 += pos0;
		pos2 += pos0;
		glBegin(GL_LINES);
		glVertex2f(rect.left0.x + scale.x * pos1.x, rect.left0.y + scale.y * pos1.y);
		glVertex2f(rect.left0.x + scale.x * pos2.x, rect.left0.y + scale.y * pos2.y);
		glEnd();
	}
		
}

void resize(int w, int h)
{
	int tx, ty, tw, th;
	GLUI_Master.get_viewport_area( &tx, &ty, &tw, &th );
	glViewport(tx, ty, tw, th);

	//r[|[gϊ
	//glViewport(0, 0, w, h);
	//\EBhẼTCY
	win_width = tw;//w;
	win_height = th;//h;
	win_ratio = (float)win_height / (float)win_width;

	glutPostRedisplay();
}

void drawContour(float PP[][NUM_MAX_Y], float minP, float maxP, Color color)
{
	glLineWidth(2.0);
	if(color == BLACK) glColor3f(0.0, 0.0, 0.0);
	else if(color == RED) glColor3f(1.0, 0.0, 0.0);
	else if(color == GREEN) glColor3f(0.0, 1.0, 0.0);
	else if(color == BLUE) glColor3f(0.0, 0.0, 1.0);
	else if(color == DARK_RED) glColor3f(0.5, 0.0, 0.0);
	else if(color == DARK_GREEN) glColor3f(0.0, 0.5, 0.0);
	else if(color == DARK_BLUE) glColor3f(0.0, 0.0, 0.5);
	else if(color == YELLOW) glColor3f(1.0, 1.0, 0.0);
	else if(color == CYAN) glColor3f(0.0, 1.0, 1.0);
	else if(color == MAGENTA) glColor3f(1.0, 0.0, 1.0);
	
	float dp0 = (maxP - minP) / (float)(nLine +1);//|eVԊu

	float pp;

	float x, y, x1, y1, x2, y2;
	int i, j, k;

    for (k = 0; k < nLine; k++)
    {
        pp = (float)(k+1) * dp0 + minP;
        for (i = 0; i < rect.nMeshX; i++)
        {
            for (j = 0; j < rect.nMeshY; j++)
            {
 				//1ł_Ȃ`
				if( type[i][j] != INSIDE && type[i+1][j] != INSIDE 
					&& type[i+1][j+1] != INSIDE && type[i][j+1] != INSIDE ) continue;
               
				x1 = -1.0; x2 = -1.0; y1 = -1.0; y2 = -1.0;

                //iq̍ӂ𒲍
                if ((pp >= PP[i][j] && pp < PP[i][j + 1]) || (pp <= PP[i][j] && pp > PP[i][j + 1]))
                {
                    x1 = (float)i;
                    y1 = (float)j + (pp - PP[i][j]) / (PP[i][j + 1] - PP[i][j]);
                }

                //ӂ𒲍
                if ((pp >= PP[i][j + 1] && pp < PP[i + 1][j + 1]) || (pp <= PP[i][j + 1] && pp > PP[i + 1][j + 1]))
                {
                    x = (float)i + (pp - PP[i][j + 1]) / (PP[i + 1][j + 1] - PP[i][j + 1]);
                    y = (float)(j + 1);
                    if (x1 < 0.0f || y1 < 0.0f)
                    {
                        x1 = x; y1 = y;
                    }
                    else
                    {
                        x2 = x; y2 = y; goto drawLine;
                    }
                }
                //Eӂ𒲍
                if ((pp >= PP[i + 1][j] && pp < PP[i + 1][j + 1]) || (pp <= PP[i + 1][j] && pp > PP[i + 1][j + 1]))
                {
                    x = (float)(i + 1) ;
                    y = (float)j  + (pp - PP[i + 1][j]) / (PP[i + 1][j + 1] - PP[i + 1][j]);

                    if (x1 < 0.0f || y1 < 0.0f)
                    {
                        x1 = x; y1 = y;
                    }
                    else
                    {
                        x2 = x; y2 = y; goto drawLine;
                    }
                }
                //ӂ𒲍

                if ((pp >= PP[i][j] && pp < PP[i + 1][j]) || (pp <= PP[i][j] && pp > PP[i + 1][j]))
                {
                    x2 = (float)i + (pp - PP[i][j]) / (PP[i + 1][j] - PP[i][j]);
                    y2 = (float)j;
                }
            drawLine: ;
                if (x1 < 0.0 || y1 < 0.0 || x2 < 0.0 || y2 < 0.0) continue;
				x1 *= rect.delta.x; x2 *= rect.delta.x;
				y1 *= rect.delta.y; y2 *= rect.delta.y;
				glBegin(GL_LINES);
				glVertex2f(rect.left0.x + scale.x * x1, rect.left0.y + scale.y * y1);
				glVertex2f(rect.left0.x + scale.x * x2, rect.left0.y + scale.y * y2);
				glEnd();
            }
        }
    }
}

void drawVelocity()
{
	int i, j;

	if(arrow == 0) widthArrow = 1.0;
	else widthArrow = 2.0;
	//`
	float theta, mag;
	for(i = 1; i < rect.nMeshX; i++)
		for (j = 1; j < rect.nMeshY; j++)
		{
			if(type[i][j] >= OBS_LEFT) continue;
			if((i/thinningV) * thinningV != i) continue;
			if((j/thinningV) * thinningV != j) continue;

			theta = atan2(Vel[i][j].y, Vel[i][j].x) * RAD_TO_DEG;
			mag = Vel[i][j].magnitude();
			glPushMatrix();
			glTranslatef(rect.left0.x + scale.x * (float)i * rect.delta.x, rect.left0.y + scale.y *  (float)j * rect.delta.y, 0.0);
			glRotatef(theta, 0.0, 0.0, 1.0);
			glScalef(scaleArrow * mag, scaleArrow * mag, 0.0);
			drawArrow();
			glPopMatrix();
		}
}
void drawArrow()
{
	glLineWidth(widthArrow);
	glColor3f(0.5, 0.0, 0.5);

	glBegin(GL_LINES);
	glVertex2f(-0.5, 0.0);
	glVertex2f( 0.5, 0.0);

	glVertex2f( 0.0, 0.2);
	glVertex2f( 0.5, 0.0);

	glVertex2f( 0.0,-0.2);
	glVertex2f( 0.5, 0.0);
	glEnd();
}

void drawGrid()
{
	glPolygonMode(GL_FRONT, GL_LINE);
	glLineWidth(1.0);
	glColor3f(0.0, 0.0, 1.0);

	int i, j;

	for(i = 1; i < rect.nMeshX; i++)
	{
		glBegin(GL_LINES);
		glVertex2f(rect.left0.x + scale.x * (float)i * rect.delta.x, rect.left0.y);
		glVertex2f(rect.left0.x + scale.x * (float)i * rect.delta.x, rect.left0.y + scale.y * rect.size.y);
		glEnd();
	}

	for(j = 1; j < rect.nMeshY; j++)
	{
		glBegin(GL_LINES);
		glVertex2f(rect.left0.x , rect.left0.y + scale.y * (float)j * rect.delta.y);
		glVertex2f(rect.left0.x + scale.x * rect.size.x, rect.left0.y + scale.y * (float)j * rect.delta.y);
		glEnd();
	}
	
	glPointSize(5);
	for(i = 1; i < rect.nMeshX; i++)
	for(j = 1; j < rect.nMeshY; j++)
	{
		//if(type[i][j] >= OBS_LEFT) glColor3f(1.0, 0.0, 0.0);
		//else glColor3f(0.0, 0.0, 1.0);
		if(type[i][j] == OBS_TOP || type[i][j] == OBS_BOTTOM || type[i][j] == OBS_LEFT || type[i][j] == OBS_RIGHT) glColor3f(1.0, 0.0, 0.0); 
		else if(type[i][j] == OBS_UL || type[i][j] == OBS_UR || type[i][j] == OBS_LL || type[i][j] == OBS_LR) glColor3f(0.0, 1.0, 0.0); 
		else glColor3f(0.0, 0.0, 1.0);

		glBegin(GL_POINTS);
		glVertex2f(rect.left0.x + scale.x * (float)i * DX, rect.left0.y + scale.y * (float)j * DY);
		glEnd();
	}
}

void drawParticle(float dt)
{
	int k, kk;
	if(!flagFreeze && countInterval == 0.0)
	{
		for(k = 0; k < numP0; k++)
		{
			//ɗq
			kk = countP + k;
			p[kk].size = sizeParticle;
			p[kk].speedC = speedCoef;
			p[kk].pos.x = 0.01;	
			p[kk].pos.y = rect.size.y * getRandom(0.0, 1.0);
			if(p[kk].pos.y < rect.size.y / 2.0) p[kk].color = RED;// DARK_YELLOW;
			else p[kk].color = BLUE;//DARK_CYAN;

		}
		countP += numP0;
//printf("size.x=%f , p[0].x = %f, p[1].y = %f \n", rect.size.x,  p[0].pos.x, p[0].pos.y);
	}

	for(k = 0; k < MAX_PARTICLE; k++)
	{
		p[k].vel = getVelocityParticle(p[k].pos);

		if(!flagFreeze) p[k].update(dt);

		if(p[k].pos.x >= 0.0 && p[k].pos.x < rect.size.x 
			&& p[k].pos.y >= 0.0 && p[k].pos.y < rect.size.y) p[k].show(rect.left0, scale);

	}

	if(countP > MAX_PARTICLE - numP0) countP = 0;
	countInterval += dt;
	if(countInterval > intervalP) {
		countInterval = 0.0;
	}
}

Vector2D getVelocityParticle(Vector2D pos)
{
	
	if( pos.x < 0.0 ) return Vector2D(-10.0, -10.0);
	if( pos.x > rect.size.x ) return Vector2D( 10.0, 10.0);
	if( pos.y <  0.0 ) return Vector2D(-10.0, -10.0);
	if( pos.y > rect.size.y ) return Vector2D( 10.0, 10.0);
	//iqԍ擾
	int I = 0, J = 0;
	for(int i = 0; i < rect.nMeshX; i++)
	{
		if((float)i * rect.delta.x < pos.x && (float)(i+1) * rect.delta.x > pos.x) I = i;
	}
	for(int j = 0; j < rect.nMeshY; j++)
	{
		if((float)j * rect.delta.y < pos.y && (float)(j+1) * rect.delta.y > pos.y) J = j;
	}
	float a =  pos.x / rect.delta.x - (float)I;
	float b =  pos.y / rect.delta.y - (float)J;
	//iq_̑x`
	Vector2D vel = (1.0 - b) * ((1.0 - a) * Vel[I][J] + a * Vel[I+1][J]) + b * ((1.0 - a) * Vel[I][J+1] + a * Vel[I+1][J+1]);
	return vel;
}
