/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

2FDM
~܂̗(S~j
ɍWϊCɓaɕsԊuiq
֐-Qx@
GPGPU(lvZGPUŎsj
CIPgp
QxPoissonɂ͉ĂȂiP񂾂j

GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

#include <windows.h>
#include <math.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath6.h"
#include "../../myPrimitive6.h"
#include "../../rigid.h"
#include "../../support3D.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
//void initData();
void idle();
void display();
void rendering();
void setTextureOmega();
void setFramebufferOmega();
void setTexturePsi();
void setFramebufferPsi();
void drawNumberingPoints();
void renewPsi();
void renewOmega(float deltaT);
//void createFloor();

//͗pf[^̃TCY
int texWidth, texHeight;//Siq

//͗pf[^z
float *omg;//Qx
float *psi;//֐Cx
GLuint texID[2];//texture object
GLuint fbo[2];//frame buffer object

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum internalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RGB;//ʂpsi[]omgr,g,b
GLenum type = GL_FLOAT;
//VF[_vO
GLuint shader_prog1, shader_prog2, shader_prog3;
int NX, NY;
float DX, DY;
int count = 0;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("GP_Cylinder");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ĕ`
	GLUI_Master.set_glutIdleFunc( idle );
	//ݒ
	glewInit();//framebuffer𗘗pƂɕKv
	init();
	initGlsl(&shader_prog1, "simulation.vert", "calcPsi.frag");
	initGlsl(&shader_prog2, "simulation.vert", "calcOmega.frag");
	initGlsl(&shader_prog3, "rendering.vert", "rendering.frag");

	setupGLUI();//myGLUI.hɎ

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
 	free(omg);
	free(psi);
	glDeleteTextures(2, texID);
	glDeleteFramebuffersEXT(2, fbo);
	glDeleteProgram(shader_prog1);
	glDeleteProgram(shader_prog2);
	glDeleteProgram(shader_prog3);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);
	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist = 80.0;
	view.vCnt = Vector3D(10.0, 0.0, 0.0);
	view.theta = 90.0;//Oi_^j
	view.phi = -90.0;//E +x
	setCamera();
	view0 = view;
	ortho_scale = 10.0;
	//parameters

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	glGenTextures(2, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(2, fbo);//t[obt@IuWFNg̐

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();
	initData();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initData()
{

	NX = region.nMesh;//a
	NY = 2 * NX;     //ʊp
	
	//~̔a1ɌŒ
	float xiMax = log(region.Radius);//vZʂɂOa(~a1.0ɌŒj
	DX = xiMax / (float)NX;//a
	DY = 2.0 * M_PI / (float)(NY); //ʊp

	//ʃeNZTCY
	texWidth  = NX + 1;//WeNX`̉TCY
	texHeight = NY + 1;//WeNX`̏cTCY
	
	//ʔz̐錾
	psi = (float*)malloc(3 * texWidth * texHeight * sizeof(float));//֐Ƒx
	omg = (float*)malloc(3 * texWidth * texHeight * sizeof(float));//QxƂ̔
	//initialize
	int i, j, k, km, kp;
	for(j = 0; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			k = i + j * texWidth;
			//Qx
			//if(j >= 5 && j <= 7 ) omg[3 * k + 0] = 10.0;
			//else
			omg[3 * k + 0] = 0.0;
			omg[3 * k + 1] = 0.0;//x
			omg[3 * k + 2] = 0.0;//y
			psi[3 * k + 0] = exp((float)i * DX) * sin((float)j * DY - M_PI);//֐(j
		}
	//iq_̑xxNg(㉺E̗֐̍ŋ߂)
	float ex;
	int jm, jp;
	for(i = 1; i < NX; i++)
	{
		ex = exp(- (float)i * DX);
		for (j = 0; j <= NY; j++)
		{
			k = i + j * texWidth;
			if(j == 0) jm = NY -1; else 
			jm = j - 1;
			//if(j == NY-1) jp = 0; else 
				jp = j + 1;
			if(j == NY) jp = 1;
			kp = i + jp * texWidth;
			km = i + jm * texWidth;
			//|eV̒Ⴂ獂
			psi[3 * k + 1] = ex * (psi[3*kp] - psi[3*km]) / (2.0*DY);//a
			psi[3 * k + 2] = -ex * (psi[3*(i+1 + j*texWidth)] - psi[3*(i-1 + j*texWidth)]) / (2.0*DX);//ʊp
		}
	}
	setTexturePsi();
	setFramebufferPsi();
	setTextureOmega();
	setFramebufferOmega();

	numRigid = 1;
	for(i = 0; i < numRigid; i++) rigid[i] = CRigid();
	//~
	rigid[0].kind = CYLINDER;
	rigid[0].color = GRAY;
	rigid[0].vPos = Vector3D(0.0, 0.0, 0.0);
	rigid[0].vSize = Vector3D(2.0, 2.0, 1.0);//a1.0

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
	elapseTime3 = 0.0;//start̑oߎ()
	count = 0;
}

void setTexturePsi()
{
	glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, psi);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setTextureOmega()
{
	glBindTexture(target, texID[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, omg);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setFramebufferPsi()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[0] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}
void setFramebufferOmega()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[1] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);
	
	if(flagStart && flagFreeze == false)
	{
		for(int n = 0; n < dispSpeed; n++)
		{
			for (int j = 0; j < NY; j++) 
			{
				//~E
				int k = j * texWidth;
				omg[3 * k] = -2.0 * psi[3*(1 + j * texWidth)] /(DX*DX);
				psi[3 * k] = 0.0;
			
				//OE
				//i == NX
				k = NX + j * texWidth;
				omg[3 * k] = omg[3 * (NX-1 + j * texWidth)];//Neumann 
				//psi[3 * k] = region.Radius * sin((float)j * DY - M_PI);
			}

			setTexturePsi();
			setFramebufferPsi();
			setTextureOmega();
			setFramebufferOmega();
			
			renewPsi();         //֐̍XV
			renewOmega(deltaT); //Qx̍XV
		}
		if(flagStep) flagFreeze = 1;
		elapseTime2 += dt;
		elapseTime3 += deltaT * dispSpeed;
		count += dispSpeed;
//printf("count = %d \n", count);
//if(count == 1000) flagFreeze = 1;
//if(count == 2500) flagFreeze = 1;
//if(count == 50000) flagFreeze = 1;

	}

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	resize(win_width, win_height);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)//'w'wireframesolid model؂ւ
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	rendering();
	rigid[0].draw();
	
//	if(flagCoordShow) drawWorldCoordinates(0.6);
	//UȂ߂̖ڈm邽
	float Courant, diff_num;
	if(DX < DY)
	{
		Courant = deltaT / DX;	
		diff_num = (1.0 / Re) * deltaT / (DX * DX);//gU
	}
	else
	{
		Courant = deltaT / DY;	
		diff_num = (1.0 / Re) * deltaT / (DY * DY);//gU
	}
	 
	if(flagParamShow && !flagOrtho) 
	{
		drawParam("f_rate=%d[fps]", fps0, 10, 30);
		drawParam("t_step=%1.5f[s]", dt, 120, 30);
		drawParam("e_time=%3.3f[s]", (float)elapseTime2, 280, 30);
		drawParam("n_time=%3.3f", elapseTime3, 440, 30);
		drawParam("Courant=%1.4f", Courant, 10, 60);
		drawParam("diff_num=%1.4f", diff_num, 150, 60);
		drawParam("Re=%3.1f", Re, 300, 60);
	}

	//obt@̐؂ւ
	glutSwapBuffers();	
}

void renewPsi()
{
	//framebuffer object1L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[0] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//psi[]
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(target, texID[1]);//omg[]
	//VF[_vOL
	glUseProgram(shader_prog1);
	GLint samplerPsiLoc = glGetUniformLocation(shader_prog1, "samplerPsi");
	glUniform1i(samplerPsiLoc, 0);//GL_TEXTURE0Kp
	GLint samplerOmgLoc = glGetUniformLocation(shader_prog1, "samplerOmg");
	glUniform1i(samplerOmgLoc, 1);//GL_TEXTURE1Kp
	GLint texWLoc = glGetUniformLocation(shader_prog1, "texWidth");
	glUniform1i(texWLoc, texWidth);
	GLint texHLoc = glGetUniformLocation(shader_prog1, "texHeight");
	glUniform1i(texHLoc, texHeight);
	GLint DXLoc = glGetUniformLocation(shader_prog1, "DX");
	glUniform1f(DXLoc, DX);
	GLint DYLoc = glGetUniformLocation(shader_prog1, "DY");
	glUniform1f(DYLoc, DY);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, psi);

	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void renewOmega(float deltaT)
{
	//framebuffer object0L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[1] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//psi[]
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(target, texID[1]);//omg[]
	//VF[_vOL
	glUseProgram(shader_prog2);
	GLint samplerPsiLoc = glGetUniformLocation(shader_prog2, "samplerPsi");
	glUniform1i(samplerPsiLoc, 0);//GL_TEXTURE0Kp
	GLint samplerOmgLoc = glGetUniformLocation(shader_prog2, "samplerOmg");
	glUniform1i(samplerOmgLoc, 1);//GL_TEXTURE1Kp
	GLint texWLoc = glGetUniformLocation(shader_prog2, "texWidth");
	glUniform1i(texWLoc, texWidth);
	GLint texHLoc = glGetUniformLocation(shader_prog2, "texHeight");
	glUniform1i(texHLoc, texHeight);
	GLint deltaTLoc = glGetUniformLocation(shader_prog2, "deltaT");
	glUniform1f(deltaTLoc, deltaT);
	GLint DXLoc = glGetUniformLocation(shader_prog2, "DX");
	glUniform1f(DXLoc, DX);
	GLint DYLoc = glGetUniformLocation(shader_prog2, "DY");
	glUniform1f(DYLoc, DY);
	GLint ReLoc = glGetUniformLocation(shader_prog2, "Re");
	glUniform1f(ReLoc, Re);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, omg);

	//printf("omg[5][NY/8] = %f  omg[10][NY/8] = %f \n", omg[3*(5 +(NY/8) * texWidth)], omg[3*(10 +(NY/8) * texWidth)]);
	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void drawNumberingPoints()
{
	//r[|[g̃TCYݒ
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	//es̐ݒ
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	//ʂeNX`Ƃē\t邽߂̉zIuWFNg
	glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
	   glVertex2f((float)i, (float)j);//_W2iq_ԍ
	glEnd();
}

void rendering()
{
	glUseProgram(shader_prog3);

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//psi[]
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(target, texID[1]);//omg[]

	GLint samplerPsiLoc = glGetUniformLocation(shader_prog3, "samplerPsi");
	glUniform1i(samplerPsiLoc, 0);//GL_TEXTURE0Kp
	GLint samplerOmgLoc = glGetUniformLocation(shader_prog3, "samplerOmg");
	glUniform1i(samplerOmgLoc, 1);//GL_TEXTURE1Kp
	GLint texWLoc = glGetUniformLocation(shader_prog3, "texWidth");
	glUniform1i(texWLoc, texWidth);
	GLint texHLoc = glGetUniformLocation(shader_prog3, "texHeight");
	glUniform1i(texHLoc, texHeight);
	GLint adjustHLoc = glGetUniformLocation(shader_prog3, "adjustH");
	glUniform1f(adjustHLoc, adjustH);
	GLint radiusLoc = glGetUniformLocation(shader_prog3, "Radius");
	glUniform1f(radiusLoc, region.Radius);
	GLint colorLoc = glGetUniformLocation(shader_prog3, "color");
	glUniform1i(colorLoc, color);
	GLint kindLoc = glGetUniformLocation(shader_prog3, "kind");
	glUniform1i(kindLoc, kind);
	GLint DXLoc = glGetUniformLocation(shader_prog3, "DX");
	glUniform1f(DXLoc, DX);
	GLint DYLoc = glGetUniformLocation(shader_prog3, "DY");
	glUniform1f(DYLoc, DY);
	GLint maxOmegaLoc = glGetUniformLocation(shader_prog3, "maxOmega");
	glUniform1f(maxOmegaLoc, maxOmega);
	GLint maxPsiLoc = glGetUniformLocation(shader_prog3, "maxPsi");
	glUniform1f(maxPsiLoc, maxPsi);
	GLint maxVelLoc = glGetUniformLocation(shader_prog3, "maxVel");
	glUniform1f(maxVelLoc, maxVel);
	GLint shadingLoc = glGetUniformLocation(shader_prog3, "flagShading");
	glUniform1i(shadingLoc, flagShading);

	static float specular[] = { 0.8, 0.8, 0.8, 1.0};
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS, 100.0);

	if(flagWireframe == 0)
		drawGridPlate((float)NX, (float)NY, NX, NY);
	else
		drawGridLines((float)NX, (float)NY, NX, NY);
	glUseProgram(0);
}
