/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

2FDM
ʂ̉QƔg\iq𐅖ʂɕׂ)
TCY20~10C200~100ɌŒ
QԂɂ镽s_Ng
x-͖@itNViEXebv@j
M[iq
GPGPU(lvZGPUŎsj
CIPgp
xPoissonɂ͉ĂȂiP񂾂j
GLSLɂVF[fBO
͂
*/
#define MAX_NUM0 50//xɕo闱q

#include <windows.h>
#include <math.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath6.h"
#include "../../myPrimitive6.h"
#include "../../rigid.h"
#include "../../support3D.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void rendering();
void setTextureVelX();
void setFramebufferVelX();
void setTextureVelY();
void setFramebufferVelY();
void setTextureWave();
void setFramebufferWave();
void drawNumberingPoints();
void renewVelX();
void renewVelY();
void renewWaveVel();
void renewWavePos();
void renewParticle();
void renderingP();
void drawPlate();
void drawParticles();
void decideRegion();
float regionFlag(float x, float y);
void setTextureParticle();
void setFramebufferParticle();

//͗pf[^̃TCY
int texWidth, texHeight;//Siq

//͗pf[^z
float *velX;//xVelXƈ
float *velY;//xVelYƉQx
float *wave;//g
float *particle;//qʒu
GLuint texID[4];//texture object
GLuint fbo[4];//framebuffer object

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum internalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RGBA;//ʂvelr,g,bшvel.a
GLenum type = GL_FLOAT;
//VF[_vO
GLuint shader_prog1, shader_prog2, shader_prog3, shader_prog4, shader_prog5, shader_prog6, shader_prog7;

enum Type{INSIDE, LEFT, RIGHT, TOP, BOTTOM, OBS_LEFT, OBS_TOP, OBS_BOTTOM,
          OBS_RIGHT, OBSTACLE, OBS_UL, OBS_UR, OBS_LL, OBS_LR};
Type g_type[NUM_MAX_X][NUM_MAX_Y]; //iq_̃^Cv

int NX, NY, NX1, NX2, NY1, NY2;
float DX, DY;

float maxPrs0, minPrs0, maxVel0, minVel0;
bool flagResetting = false;

int nDummy;
int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("GP_VortexWave1");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ĕ`
	GLUI_Master.set_glutIdleFunc( idle );
	//ݒ
	glewInit();//framebuffer𗘗pƂɕKv
	init();
	initGlsl(&shader_prog1, "simulation.vert", "calcVelocityX.frag");
	initGlsl(&shader_prog2, "simulation.vert", "calcVelocityY.frag");
	initGlsl(&shader_prog3, "simulation.vert", "waveVel.frag");
	initGlsl(&shader_prog4, "simulation.vert", "wavePos.frag");
	initGlsl(&shader_prog5, "rendering.vert", "rendering.frag");
	initGlsl(&shader_prog6, "simulation.vert", "particle.frag");//qp
	initGlsl(&shader_prog7, "renderingP.vert");//qp

	setupGLUI();//myGLUI.hɎ

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
 	free(velX);
	free(velY);
	free(wave);
	free(particle);
	glDeleteTextures(4, texID);
	glDeleteFramebuffersEXT(4, fbo);
	glDeleteProgram(shader_prog1);
	glDeleteProgram(shader_prog2);
	glDeleteProgram(shader_prog3);
	glDeleteProgram(shader_prog4);
	glDeleteProgram(shader_prog5);
	glDeleteProgram(shader_prog6);
	glDeleteProgram(shader_prog7);
	deleteDisplayLists();
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);
	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist = 25.0;
	view.vCnt = Vector3D(0.0, 0.5, 0.0);
	view.theta = 90.0;//Oi_^j
	view.phi = -90.0;//E +x
	setCamera();
	view0 = view;
	ortho_scale = 10.0;

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);
	elapseTime2 = 0.0;//start̑oߎ
	elapseTime3 = 0.0;//start̑oߎ(j

	glGenTextures(4, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(4, fbo);//t[obt@IuWFNg̐

	//\EBhEɕ_O鏀
	setFontBitmaps();

	//display list쐬
	createDisplayLists();

	initData();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initData()
{	
	DX = rect.size.x / (float)rect.meshX;
	DY = rect.size.y / (float)rect.meshY;

	nDummy = 20;//ő30
	NX = rect.meshX + 2 * nDummy;
	NY = rect.meshY + 2 * nDummy;         

	rect.obs_posY = rect.size.y / 2.0;
	
	//QE̕_ԍ
	float eps = 0.5;
	int NX1 = nDummy + floor((rect.obs_left - rect.obs_thick / 2.0) / DX + eps);//Q[ʒu
	int NX2 = nDummy + floor((rect.obs_left + rect.obs_thick / 2.0) / DX + eps);//QE[ʒu
	int NY2 = nDummy + floor((rect.obs_posY + rect.obs_width/2.0) / DY + eps);//Q[ʒu
	int NY1 = nDummy + floor((rect.obs_posY - rect.obs_width/2.0) / DY + eps);//Q[ʒu

	//iq_̃^Cv
	int i, j;
	for(i = 0; i <= NX; i++)
		for(j = 0; j <= NY; j++)
		{
			g_type[i][j] = INSIDE;//_
			if(j == 0) g_type[i][j] = BOTTOM;//ǖ
			if(j == NY) g_type[i][j] = TOP;//㑤ǖ
			if(i == 0) g_type[i][j] = LEFT;//[
			if(i == NX) g_type[i][j] = RIGHT;//o[
			if(i == NX1 && j > NY1 && j < NY2) g_type[i][j] = OBS_LEFT;//Q[
			if(i == NX2 && j > NY1 && j < NY2) g_type[i][j] = OBS_RIGHT;//QE[
			if(i >= NX1 && i <= NX2 && j == NY2) g_type[i][j] = OBS_TOP;//Q[
			if(i >= NX1 && i <= NX2 && j == NY1) g_type[i][j] = OBS_BOTTOM;//Q[
			if(i > NX1 && i < NX2 && j > NY1 && j < NY2) g_type[i][j] = OBSTACLE;//Q
			if(i == NX1 && j == NY1) g_type[i][j] = OBS_LL;
			if(i == NX1 && j == NY2) g_type[i][j] = OBS_UL;
			if(i == NX2 && j == NY1) g_type[i][j] = OBS_LR;
			if(i == NX2 && j == NY2)  g_type[i][j] = OBS_UR;
		}

	//ʃeNZTCY
	texWidth  = NX + 1;//WeNX`̉TCY
	texHeight = NY + 1;//WeNX`̏cTCY
	
	//ʔz
	velX = (float*)malloc(4 * texWidth * texHeight * sizeof(float));//Xx̔ш(A)
	velY = (float*)malloc(4 * texWidth * texHeight * sizeof(float));//YxƂ̔(A͕\pQx)
	wave = (float*)malloc(4 * texWidth * texHeight * sizeof(float));//ʂ̂xƕψʗ

	//initialize
	int k, I, J;
	for(j = 0; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			k = i + j * texWidth;
			//I = i - nDummy; J = j - nDummy;//nDummylȂƂ̊iqԍ
			//xX
			velX[4 * k + 0] = 1.0;
			velX[4 * k + 1] = 0.0;//x
			velX[4 * k + 2] = 0.0;//y
			velX[4 * k + 3] = 0.0;//
			if(g_type[i][j] == BOTTOM || g_type[i][j] == TOP || g_type[i][j] >= OBS_LEFT) velX[4 * k + 0] = 0.0;//Q\
			//xY
			velY[4 * k + 0] = 0.0;
			velY[4 * k + 1] = 0.0;//x
			velY[4 * k + 2] = 0.0;//y
			velY[4 * k + 3] = 0.0;//\pQxiGPUŗp)
			//eiq_ɂ鐅ʂ̍Ƃx
			wave[k * 4 + 0] = 0.0;//ʂ̂x
			wave[k * 4 + 1] = 0.0;//ʂ̕ψʗ
			wave[k * 4 + 2] = 0.0;
			wave[k * 4 + 3] = 1.0;//QOɗp		
		}

	setTextureVelX();
	setFramebufferVelX();
	setTextureVelY();
	setFramebufferVelY();

	//Q
	//SẴp^[ɋ
	numRigid = 1;
	for(i = 0; i < RIGID_NUM_MAX; i++)	rigid[i] = CRigid();
	
	rigid[0].kind = CUBE;
	rigid[0].color = DARK_YELLOW;
	rigid[0].vSize = Vector3D(rect.obs_thick, rect.obs_width, 1.0);
//	rigid[0].vPos = Vector3D(0.0, 0.0, 0.0);
	rigid[0].vPos = Vector3D(-rect.size.x/2.0 + rect.obs_left, 0.0, 0.0);
//printf("left=%f \n",rect.obs_left); 
	float wid = 0.4;
	float hig = 0.5;
	if(pattern == 1)
	{
		numRigid = 3;
		rigid[1].kind = CUBE;
		rigid[1].color = GRAY;
		rigid[1].vSize = Vector3D(rect.size.x, wid, hig);
		rigid[1].vPos = Vector3D(0.0, rect.size.y/2.0 + 0.5*wid , 0.0);

		rigid[2].kind = CUBE;
		rigid[2].color = GRAY;
		rigid[2].vSize = Vector3D(rect.size.x, wid, hig);
		rigid[2].vPos = Vector3D(0.0, -rect.size.y/2.0 - 0.5*wid , 0.0);
	}
	decideRegion();
	setTextureWave();
	setFramebufferWave();

	//q
	particle = (float*)malloc(4 * texWidth * texHeight * sizeof(float));//q̈ʒu

	for(j = 0; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			k = i + j * texWidth;
			if(k > numParticle) break;
			particle[4 * k + 0] = getRandom(-rect.size.x/2.0, rect.size.x/2.0);
			particle[4 * k + 1] = getRandom(-rect.size.y/2.0, rect.size.y/2.0);
			particle[4 * k + 2] = 0.0;
			particle[4 * k + 3] = 0.0;//iq_̉tʂ̍
		}
	setTextureParticle();
	setFramebufferParticle();

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
	elapseTime3 = 0.0;//start̑oߎ()

}

void setTextureVelX()
{
	glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, velX);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setTextureVelY()
{
	glBindTexture(target, texID[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, velY);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setFramebufferVelX()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[0] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}
void setFramebufferVelY()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[1] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}
void setTextureWave()
{
	glBindTexture(target, texID[2]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, wave);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setFramebufferWave()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[2] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[2], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void setTextureParticle()
{
	glBindTexture(target, texID[3]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, GL_FLOAT, particle);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setFramebufferParticle()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[3] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[3], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}


void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);
	
	int i, j, k, k1;

	if(flagStart==true && flagFreeze == false) 
	{
		for(int m = 0; m < dispSpeed; m++)//^CXebvdeltaT͕ςɕ\xς
		{
			//xE
			for (j = 0; j <= NY; j++) 
			{
				//
				k = 4 * (j * texWidth);
				velX[k] = 1.0;
				velY[k] = 0.0;
				//o
				k = 4 * (NX + j * texWidth);
				k1 = 4 * (NX - 1 + j * texWidth);
				velX[k] = velX[k1]; 
				velY[k] = velY[k1]; 
			}
			//Q\ʂѓ
			for (i = 1; i < NX; i++)
				for (j = 0; j <= NY; j++) 
				{
					if(g_type[i][j] < OBS_LEFT) continue;
					k = 4 * (i + j * texWidth);
					velX[k] = 0.0;
					velY[k] = 0.0;
				}
			
			//͋E(Qj
			//S̈̋Eɑ΂ĂDirichlet
			for (i = 0; i <= NX; i++)
				for (j = 0; j <= NY; j++) 
				{
					k = 4 * (i + j * texWidth) + 3;//
					if(g_type[i][j] == INSIDE) continue;
					else if(g_type[i][j] == LEFT)  velX[k] = 0.0;
					else if(g_type[i][j] == RIGHT) velX[k] = 0.0;
					else if(g_type[i][j] == TOP) velX[k] = 0.0;
					else if(g_type[i][j] == BOTTOM) velX[k] = 0.0;
					else if(g_type[i][j] == OBS_LEFT) velX[k] = velX[4 * (i-1 + j * texWidth) + 3];
					else if(g_type[i][j] == OBS_RIGHT) velX[k] = velX[4 * (i+1 + j * texWidth) + 3];
					else if(g_type[i][j] == OBS_TOP) velX[k] = velX[4 * (i + (j+1) * texWidth) + 3];
					else if(g_type[i][j] == OBS_BOTTOM) velX[k] = velX[4 * (i + (j-1) * texWidth) + 3];
					else if(g_type[i][j] == OBS_UL) velX[k] = velX[4 * (i-1 + (j+1) * texWidth) + 3];
					else if(g_type[i][j] == OBS_UR) velX[k] = velX[4 * (i+1 + (j+1) * texWidth) + 3];
					else if(g_type[i][j] == OBS_LL) velX[k] = velX[4 * (i-1 + (j-1) * texWidth) + 3];
					else if(g_type[i][j] == OBS_LR) velX[k] = velX[4 * (i+1 + (j-1) * texWidth) + 3];
				}

			setTextureVelX();
			setFramebufferVelX();
			setTextureVelY();
			setFramebufferVelY();
			
			renewVelX(); //xXƈ͂̍XV
			renewVelY(); //xYƉQx̍XV

			renewWaveVel();//ĝx̍XV
			renewWavePos();//g̐ʕψʗʂ̍XV

			//particle
			for(j = 0; j < texHeight; j++)
			for(i = 0; i < texWidth; i++)
			{
				k = i + j * texWidth;
				if(k > numParticle) break;
				//̈O̗q͗[
				if(particle[4 * k + 0] > rect.size.x/2.0 || particle[4 * k + 1] > rect.size.y/2.0 || particle[4 * k + 1] < -rect.size.y/2.0)
				{
					particle[4 * k + 0] = -rect.size.x/2.0;
					particle[4 * k + 1] = getRandom(-rect.size.y/2.0, rect.size.y/2.0);
				}
			}
			setTextureParticle();
			setFramebufferParticle();

			renewParticle();//qʒu̍XV
		}
		if(flagStep) flagFreeze = true;
		elapseTime2 += dt;
		elapseTime3 += deltaT;
	}

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	resize(win_width, win_height);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)//'w'wireframesolid model؂ւ
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	rendering();

	if(flagShowParticle) renderingP();
	
	for(k = 0; k < numRigid; k++) rigid[k].draw();

	//UȂ߂̖ڈm邽
	float Courant, diff_num;
	if(DX < DY)
	{
		Courant = deltaT / DX;	
		diff_num = (1.0 / Re) * deltaT / (DX * DX);//gU
	}
	else
	{
		Courant = deltaT / DY;	
		diff_num = (1.0 / Re) * deltaT / (DY * DY);//gU
	}
	 
	if(flagParamShow && !flagOrtho) 
	{
		drawParam("f_rate=%d[fps]", fps0, 10, 30);
		drawParam("t_step=%1.5f[s]", dt, 150, 30);
		drawParam("e_time=%3.3f[s]", elapseTime2, 300, 30);
		drawParam("n_time=%3.3f", elapseTime3, 460, 30);
		drawParam("Courant=%1.4f", Courant, 10, 50);
		drawParam("diff_num=%1.4f", diff_num, 150, 50);
		drawParam("Re=%3.1f", Re,300, 50);
	}
	//if(flagResetting) drawParam("Reset obstacle size",  200, 200.0);
	if(flagCoordShow) drawWorldCoordinates(5.0);

	//obt@̐؂ւ
	glutSwapBuffers();	
}

void renewVelX()
{
	//framebuffer object1L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[0] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//velX[]
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(target, texID[1]);//velY[]
	//VF[_vOL
	glUseProgram(shader_prog1);
	GLint samplerVelXLoc = glGetUniformLocation(shader_prog1, "samplerVelX");
	glUniform1i(samplerVelXLoc, 0);//GL_TEXTURE0Kp
	GLint samplerVelYLoc = glGetUniformLocation(shader_prog1, "samplerVelY");
	glUniform1i(samplerVelYLoc, 1);//GL_TEXTURE1Kp
	GLint texWLoc = glGetUniformLocation(shader_prog1, "texWidth");
	glUniform1i(texWLoc, texWidth);
	GLint texHLoc = glGetUniformLocation(shader_prog1, "texHeight");
	glUniform1i(texHLoc, texHeight);
	GLint deltaTLoc = glGetUniformLocation(shader_prog1, "deltaT");
	glUniform1f(deltaTLoc, deltaT);
	GLint DXLoc = glGetUniformLocation(shader_prog1, "DX");
	glUniform1f(DXLoc, DX);
	GLint DYLoc = glGetUniformLocation(shader_prog1, "DY");
	glUniform1f(DYLoc, DY);
	GLint ReLoc = glGetUniformLocation(shader_prog1, "Re");
	glUniform1f(ReLoc, Re);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, velX);//f[^CPU

	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void renewVelY()
{
	//framebuffer object1L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[1] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//velX[]
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(target, texID[1]);//veYl[]
	//VF[_vOL
	glUseProgram(shader_prog2);
	GLint samplerVelXLoc = glGetUniformLocation(shader_prog2, "samplerVelX");
	glUniform1i(samplerVelXLoc, 0);//GL_TEXTURE0Kp
	GLint samplerVelYLoc = glGetUniformLocation(shader_prog2, "samplerVelY");
	glUniform1i(samplerVelYLoc, 1);//GL_TEXTURE1Kp
	GLint texWLoc = glGetUniformLocation(shader_prog2, "texWidth");
	glUniform1i(texWLoc, texWidth);
	GLint texHLoc = glGetUniformLocation(shader_prog2, "texHeight");
	glUniform1i(texHLoc, texHeight);
	GLint deltaTLoc = glGetUniformLocation(shader_prog2, "deltaT");
	glUniform1f(deltaTLoc, deltaT);
	GLint DXLoc = glGetUniformLocation(shader_prog2, "DX");
	glUniform1f(DXLoc, DX);
	GLint DYLoc = glGetUniformLocation(shader_prog2, "DY");
	glUniform1f(DYLoc, DY);
	GLint ReLoc = glGetUniformLocation(shader_prog2, "Re");
	glUniform1f(ReLoc, Re);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, velY);//f[^CPU

	//printf("vel[5][NY/8] = %f  vel[10][NY/8] = %f \n", vel[3*(5 +(NY/8) * texWidth)], vel[3*(10 +(NY/8) * texWidth)]);
	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void renewWaveVel()
{
	//framebuffer object2L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[2] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[2]);//wave[]
	//VF[_vOL
	glUseProgram(shader_prog3);
	GLint samplerWaveLoc = glGetUniformLocation(shader_prog3, "samplerWave");
	glUniform1i(samplerWaveLoc, 0);//GL_TEXTURE2Kp
	GLint texWidthLoc = glGetUniformLocation(shader_prog3, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint texHeightLoc = glGetUniformLocation(shader_prog3, "texHeight");
	glUniform1i(texHeightLoc, texHeight);
	GLint meshXLoc = glGetUniformLocation(shader_prog3, "meshX");
	glUniform1i(meshXLoc, rect.meshX);
	GLint meshYLoc = glGetUniformLocation(shader_prog3, "meshY");
	glUniform1i(meshYLoc, rect.meshY);
	GLint dummyLoc = glGetUniformLocation(shader_prog3, "nDummy");
	glUniform1i(dummyLoc, nDummy);
	GLint sizeXLoc = glGetUniformLocation(shader_prog3, "sizeX");
	glUniform1f(sizeXLoc, rect.size.x);
	GLint sizeYLoc = glGetUniformLocation(shader_prog3, "sizeY");
	glUniform1f(sizeYLoc, rect.size.y);
	GLint ampLoc = glGetUniformLocation(shader_prog3, "amp");
	glUniform1f(ampLoc, amp0);
	GLint freqLoc = glGetUniformLocation(shader_prog3, "freq");
	glUniform1f(freqLoc, freq0);
	GLint timeLoc = glGetUniformLocation(shader_prog3, "time");
	glUniform1f(timeLoc, elapseTime2);
	GLint nSourceLoc = glGetUniformLocation(shader_prog3, "nSource");
	glUniform1i(nSourceLoc, nSource0);
	GLint sourceXLoc = glGetUniformLocation(shader_prog3, "sourceX");
	glUniform1i(sourceXLoc, sourceX0);
	GLint intervalLoc = glGetUniformLocation(shader_prog3, "interval");
	glUniform1i(intervalLoc, interval0);
	GLint dragLoc = glGetUniformLocation(shader_prog3, "drag0");
	glUniform1f(dragLoc, drag0);
	GLint waveSpeedLoc = glGetUniformLocation(shader_prog3, "waveSpeed");
	glUniform1f(waveSpeedLoc, waveSpeed);
	GLint dtLoc = glGetUniformLocation(shader_prog3, "dt");
	glUniform1f(dtLoc, deltaT);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);
	//glReadPixels(0, 0, texWidth, texHeight, format, type, wave);
	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void renewWavePos()
{
	//framebuffer object2L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[2] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//velX[]
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(target, texID[1]);//veYl[]
	glActiveTexture(GL_TEXTURE2);
	glBindTexture(target, texID[2]);//wave[]
	//VF[_vOL
	glUseProgram(shader_prog4);
	GLint samplerVelXLoc = glGetUniformLocation(shader_prog4, "samplerVelX");
	glUniform1i(samplerVelXLoc, 0);//GL_TEXTURE0Kp
	GLint samplerVelYLoc = glGetUniformLocation(shader_prog4, "samplerVelY");
	glUniform1i(samplerVelYLoc, 1);//GL_TEXTURE1Kp
	GLint samplerWaveLoc = glGetUniformLocation(shader_prog4, "samplerWave");
	glUniform1i(samplerWaveLoc, 2);//GL_TEXTURE0Kp
	GLint texWidthLoc = glGetUniformLocation(shader_prog4, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint texHeightLoc = glGetUniformLocation(shader_prog4, "texHeight");
	glUniform1i(texHeightLoc, texHeight);
	GLint maxOmgLoc = glGetUniformLocation(shader_prog4, "maxOmg");
	glUniform1f(maxOmgLoc, maxOmg);
	GLint maxPrsLoc = glGetUniformLocation(shader_prog4, "maxPrs");
	glUniform1f(maxPrsLoc, maxPrs);
	GLint dtLoc = glGetUniformLocation(shader_prog4, "dt");
	glUniform1f(dtLoc, deltaT);

	drawNumberingPoints();//l͗p̃eNX`iʁj\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);
	//glReadPixels(0, 0, texWidth, texHeight, format, type, wave);
	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void drawNumberingPoints()
{
	//r[|[g̃TCYݒ
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	//es̐ݒ
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	//ʂeNX`Ƃē\t邽߂̉zIuWFNg
	glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++) glVertex2f((float)i, (float)j);//_W2iq_ԍ
	glEnd();

}

void rendering()
{
	glUseProgram(shader_prog5);
	glActiveTexture(GL_TEXTURE2);
	glBindTexture(target, texID[2]);//wave[]

	GLint samplerWaveLoc = glGetUniformLocation(shader_prog5, "samplerWave");
	glUniform1i(samplerWaveLoc, 2);//GL_TEXTURE2Kp
	GLint texWLoc = glGetUniformLocation(shader_prog5, "texWidth");
	glUniform1i(texWLoc, texWidth);
	GLint texHLoc = glGetUniformLocation(shader_prog5, "texHeight");
	glUniform1i(texHLoc, texHeight);
	GLint sizeXLoc = glGetUniformLocation(shader_prog5, "sizeX");
	glUniform1f(sizeXLoc, rect.size.x);
	GLint sizeYLoc = glGetUniformLocation(shader_prog5, "sizeY");
	glUniform1f(sizeYLoc, rect.size.y);
	GLint meshXLoc = glGetUniformLocation(shader_prog5, "meshX");
	glUniform1i(meshXLoc, rect.meshX);
	GLint meshYLoc = glGetUniformLocation(shader_prog5, "meshY");
	glUniform1i(meshYLoc, rect.meshY);

	GLint adjustHLoc = glGetUniformLocation(shader_prog5, "adjustH");
	glUniform1f(adjustHLoc, adjustH);

	static float diffuse[] = { 0.1, 0.3, 0.9, 1.0};
	static float specular[] = { 0.7, 0.7, 0.7, 1.0};
	glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE, diffuse);
	glMaterialfv(GL_FRONT,GL_SPECULAR,specular);
	glMaterialf(GL_FRONT,GL_SHININESS, 100.0);

	if(flagWireframe == 0)
		drawGridPlate((float)rect.meshX, (float)rect.meshY, rect.meshX, rect.meshY);
	else
		drawGridLines((float)rect.meshX, (float)rect.meshY, rect.meshX, rect.meshY);
	glUseProgram(0);
}

void renewParticle()
{
	//framebuffer objectL
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[3] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//velX
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(target, texID[1]);//velY
	glActiveTexture(GL_TEXTURE2);
	glBindTexture(target, texID[2]);//wave[]
	glActiveTexture(GL_TEXTURE3);
	glBindTexture(target, texID[3]);//particle[]

	glUseProgram(shader_prog6);
	GLint samplerVelXLoc = glGetUniformLocation(shader_prog6, "samplerVelX");
	glUniform1i(samplerVelXLoc, 0);//GL_TEXTURE0Kp
	GLint samplerVelYLoc = glGetUniformLocation(shader_prog6, "samplerVelY");
	glUniform1i(samplerVelYLoc, 1);//GL_TEXTURE1Kp
	GLint samplerWaveLoc = glGetUniformLocation(shader_prog6, "samplerWave");
	glUniform1i(samplerWaveLoc, 2);//GL_TEXTURE2Kp
	GLint samplerPosLoc = glGetUniformLocation(shader_prog6, "samplerPosP");
	glUniform1i(samplerPosLoc, 3);//GL_TEXTURE3Kp
/*	GLint texWidthLoc = glGetUniformLocation(shader_prog6, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint texHeightLoc = glGetUniformLocation(shader_prog6, "texHeight");
	glUniform1i(texHeightLoc, texHeight);*/
	GLint meshXLoc = glGetUniformLocation(shader_prog6, "meshX");
	glUniform1i(meshXLoc, rect.meshX);
	GLint meshYLoc = glGetUniformLocation(shader_prog6, "meshY");
	glUniform1i(meshYLoc, rect.meshY);
	GLint dummyLoc = glGetUniformLocation(shader_prog6, "nDummy");
	glUniform1i(dummyLoc, nDummy);
	GLint adjustHLoc = glGetUniformLocation(shader_prog6, "adjustH");
	glUniform1f(adjustHLoc, adjustH);
/*
	GLint maxOmgLoc = glGetUniformLocation(shader_prog6, "maxOmg");
	glUniform1f(maxOmgLoc, maxOmg);
	GLint maxPrsLoc = glGetUniformLocation(shader_prog6, "maxPrs");
	glUniform1f(maxPrsLoc, maxPrs);
*/
	GLint sizeXLoc = glGetUniformLocation(shader_prog6, "sizeX");
	glUniform1f(sizeXLoc, rect.size.x);
	GLint sizeYLoc = glGetUniformLocation(shader_prog6, "sizeY");
	glUniform1f(sizeYLoc, rect.size.y);
	GLint numParticleLoc = glGetUniformLocation(shader_prog6, "numParticle");
	glUniform1i(numParticleLoc, numParticle);

	GLint dtLoc = glGetUniformLocation(shader_prog6, "dt");
	glUniform1f(dtLoc, deltaT);

	drawNumberingPoints();
	// VF[_vỎ 
	glUseProgram(0);
	//XVf[^ixƈʒujeNX`ɃRs[
	//glCopyTexSubImage2D(target, 0, 0, 0, 0, 0, texWidth, texHeight);
	glReadPixels(0, 0, texWidth, texHeight, format, type, particle);//f[^CPU
	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

}

void renderingP()
{
	//`	
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[3]);
	glUseProgram(shader_prog7);
	GLint samplerLoc = glGetUniformLocation(shader_prog7, "samplerPosP");
	glUniform1i(samplerLoc, 0);//GL_TEXTURE0Kp

	drawParticles();
	glUseProgram(0);

	glBindTexture(target, 0);
}
void drawParticles()
{
	glDisable(GL_LIGHTING);
	glPointSize(sizeParticle);
	glColor3f(1.0, 1.0, 1.0);

	glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++) glVertex3f((float)i, (float)j, 0.0);
	glEnd();
	glPointSize(1);
	glEnable(GL_LIGHTING);
}
void decideRegion()
{
	int i, j, k;
	float x, y;

	for(j = 0; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			k = i + j * texWidth;
			//iq_̍W
			x = (float)(i - texWidth / 2) * DX;
			y = (float)(j - texHeight / 2) * DY;
			wave[k * 4 + 3] = regionFlag(x, y);
			if(wave[k * 4 + 3] == 0.0) g_type[i][j] = OBSTACLE;
		}
}

float regionFlag(float x, float y)
{//Ώې}`̊{pŔ
	Vector3D vPoint0 = Vector3D(x, y, 0.0);
	Vector3D vPoint;

	for(int k = 0; k < numRigid; k++)
	{
		//Ώې}`̒Sɕsړ̉]
		vPoint = vPoint0 - rigid[k].vPos;
		vPoint.rotZ(-rigid[k].vEuler.z);
		if(rigid[k].kind == CUBE)
		{
			if( vPoint.x >= - rigid[k].vSize.x / 2.0 && vPoint.x <= rigid[k].vSize.x / 2.0
			 && vPoint.y >= - rigid[k].vSize.y / 2.0 && vPoint.y <= rigid[k].vSize.y / 2.0) return 0.0;//Q
		}
		else if(rigid[k].kind == SPHERE || rigid[k].kind == CYLINDER)
		{
			//ȉ~`
			float a = rigid[k].vSize.x * rigid[k].vSize.x / 4.0;
			float b = rigid[k].vSize.y * rigid[k].vSize.y / 4.0;
			float f =  vPoint.x*vPoint.x / a + vPoint.y*vPoint.y / b - 1.0;
			if(f <= 0.0) return 0.0;
		}
	}
	return 1.0;//O()
}


