#extension GL_ARB_texture_rectangle: enable
uniform sampler2DRect samplerVelX;
uniform sampler2DRect samplerVelY;
uniform sampler2DRect samplerWave;
uniform sampler2DRect samplerPosP;
uniform int meshX, meshY, nDummy;
uniform float adjustH;
uniform float maxOmg, maxPrs;
uniform float sizeX;
uniform float sizeY;
uniform int numParticle;
uniform float dt;
varying vec2 texPos;


void main(void)
{

	float pp = texture2DRect(samplerWave, texPos).b * adjustH;//ʂ̕ϓ

	//q̈ʒuWvZ
	vec3 posP;
	float deltaX = sizeX / float(meshX);
	float deltaY = sizeY / float(meshY);

	posP = texture2DRect(samplerPosP, texPos).xyz;//q̈ʒu
	//̈ʒuɍł߂iq_
	float I = float(nDummy) + (posP.x + sizeX/2.0) / deltaX;
	float J = float(nDummy) + (posP.y + sizeY/2.0) / deltaY;
	//iq_̗̑x
	float velX = texture2DRect(samplerVelX, vec2(I, J)).r;	
	float velY = texture2DRect(samplerVelY, vec2(I, J)).r;
	vec3 velP = vec3(velX, velY, 0.0);

	//qʒu̍XV
	posP.xy += velP.xy * dt;
	posP.z = texture2DRect(samplerPosP, vec2(I, J)).a;

	gl_FragColor = vec4(posP, pp);
}


