/*
Microsoft Visual Studio .NET2005 Standard Edition
vWFNg̎ށFVisualC++vWFNg
ev[gFWin32R\[vWFNg
AvP[V̎ށFR\[AvP[V
ǉ̃IvVF̃vWFNg

2ڗgU(CIPgp)
3D\
xԓIɕω(]xj
GPGPU(lvZGPUŎsj

GLSLɂVF[fBO
͂
(ݒFx͎OCy͉Ej
*/

#include <windows.h>
#include <math.h>
#include <GL/glew.h>
#include <GL/glui.h>
#include "../../myGlsl.h"
#include "../../myMath6.h"
#include "../../myPrimitive6.h"
#include "../../support3D.h"
#include "myGLUI.h"

//֐̃vg^Cv錾
void init();
void idle();
void display();
void rendering();
void setTexturePhi();
void setFramebufferPhi();
void setTextureVel();
void setFramebufferVel();
void drawNumberingPoints();
void renewPhi(float deltaT, float d);
void createFloor();

//͗pf[^̃TCY
int texWidth, texHeight;//Siq

//͗pf[^z
float *phi, *vel;
GLuint texID[2];//texture object
GLuint fbo[2];//frame buffer object

GLenum target = GL_TEXTURE_RECTANGLE_ARB;
GLenum internalFormat = GL_RGBA32F_ARB;
GLenum format = GL_RGB;//ʂphi[]r,g,b
GLenum type = GL_FLOAT;
//VF[_vO
GLuint shader_prog1, shader_prog2;

int floor0;//floordisplay list
float maxSpeed;//]^̍ő呬x

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	//\[h
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	//\EBhẼTCY
	glutInitWindowSize(win_width, win_height);
	//̈ʒu
	glutInitWindowPosition(win_x0, win_y0);
	//EBhE쐬
	main_window = glutCreateWindow("GP_AdvDiffusion2D");
	//EBhẼTCYύX
	glutReshapeFunc(resize);
	//\
	glutDisplayFunc(display);
	//}EX
	glutMouseFunc(mouse);
	glutMotionFunc(motion);
	//ĕ`
	glutIdleFunc(idle);
	//ݒ
	glewInit();//framebuffer𗘗pƂɕKv
	init();
	initGlsl(&shader_prog1, "simulation.vert", "simulation.frag");
	initGlsl(&shader_prog2, "rendering.vert", "rendering.frag");

	setupGLUI();//myGLUI.hɎ
	GLUI_Master.set_glutIdleFunc( idle );

	//Cxg[vɓ
	glutMainLoop();
	//\[X̉
 	free(phi);
	free(vel);
	glDeleteTextures(2, texID);
	glDeleteFramebuffersEXT(2, fbo);
	glDeleteProgram(shader_prog1);
	glDeleteProgram(shader_prog2);
	return 0;
}

void idle(void)
{
	//RedisplaybZ[Wmai_windowɂȂ悤ɃZbg
	if(glutGetWindow() != main_window ) glutSetWindow(main_window);  
	//ĕ`
	glutPostRedisplay();
}

void init(void)
{
	//wiF
	glClearColor(0.2, 0.2, 0.3, 1.0);
	setCamera();//_߂
	setLight(); //ݒ@
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_NORMALIZE);
	
	//JƎ̐ς̏l̕ύXiView̐錾setup.h)
	view.dist = 30.0;
	view.vCnt = Vector3D(0.0, 0.0, 2.0);
	view.theta = 10.0;//Oi_^j
	view.phi = -90.0;//E +x
	view.fovY = 20.0;
	view.nearZ =  0.1;
	view.farZ = 200.0;    
	setCamera();
	view0 = view;
	//parameters

	//Ԋ֌W
	memset(&freq,  0x00, sizeof freq);
	memset(&lastTime, 0x00, sizeof lastTime);
	memset(&currentTime, 0x00, sizeof currentTime);
	QueryPerformanceCounter( &lastTime);

	glGenTextures(2, texID);//eNX`IuWFNg̖Ot
	glGenFramebuffersEXT(2, fbo);//t[obt@IuWFNg̐

	//\EBhEɕ_O鏀
	setFontBitmaps();

	initData();
	createFloor();

	//L[̐
	printf("}EXŎ_ύX \n");
	printf("  dollyFt߂{^NbNŋ߂ÂCE{^NbNŉ \n");
	printf("  panFщEE{^NbNŒ_Eɕω \n");
	printf("  tiltF^エѐ^E{^NbNŒ_㉺ɕω \n");
	printf("  tumbleFEɃhbOƎ_Eɕω \n");
	printf("  craneF㉺ɃhbOƎ_㉺ɕω \n");
	printf("  zoomFE{^NbNŃY[C \n");
	printf("        EE{^NbNŃY[AEg \n");
}

void initData()
{
	flagFreeze = 0;
	flagStep = 0;

	rect.delta.x = rect.size.x / (float)rect.nMesh;
	rect.delta.y = rect.size.y / (float)rect.nMesh;

	//ʃeNZTCY
	texWidth  = rect.nMesh + 1;//WeNX`̉TCY
	texHeight = texWidth;      //WeNX`̏cTCY
	//ʔz̐錾
	phi = (float*)malloc(3 * texWidth * texHeight * sizeof(float));
	vel = (float*)malloc(3 * texWidth * texHeight * sizeof(float));
	
	int i, j, k;
	float x, y, r;

	maxSpeed = 0.0; 
	float speed;
	for(j = 0; j < texHeight; j++)
		for(i = 0; i < texWidth; i++)
		{
			k = i + j * texWidth;
			//zS̋
			x = (float)i * rect.delta.x - centerInit.x ;
			y = (float)j * rect.delta.y - centerInit.y ;
			if(profile == 0)//Cylinder
			{
				r = sqrt(x * x + y * y);
				if(r < radiusInit) phi[3*k] = 1.0;//ʁixCZxetc.)
				else phi[3*k] = 0.0;
			}
			else//Cube
			{
				if(fabs(x) < radiusInit && fabs(y) < radiusInit) phi[3*k] = 1.0;//ʁixCZxetc.)
				else phi[3*k] = 0.0;
			}
			//l
			phi[3*k + 1] = 0.0;//gx=df/dx
			phi[3*k + 2] = 0.0;//gy=df/dy

			if(flagRotation)
			{
				//`S̋
				x = (float)(i - texWidth/2) * rect.delta.x ;
				y = (float)(j - texHeight/2) * rect.delta.y ;
				vel[3 * k]     = speedR * y; //xx(vj
				vel[3 * k + 1] = -speedR * x;//xy
				vel[3 * k + 2] = 0.0;//gp
				speed = speedR * sqrt(x*x + y*y);
				if(speed > maxSpeed) maxSpeed = speed;
			}
			else//is
			{
				vel[3 * k]     = velocity.x;//xx
				vel[3 * k + 1] = velocity.y;//xy
				vel[3 * k + 2] = 0.0;//gp
			}
		}
	setTexturePhi();
	setFramebufferPhi();
	setTextureVel();
	setFramebufferVel();

	elapseTime1 = 0.0;//1secԈȓ̌oߎ
	elapseTime2 = 0.0;//start̑oߎ
}

void setTexturePhi()
{
	glBindTexture(target, texID[0]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, phi);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setTextureVel()
{
	glBindTexture(target, texID[1]);
	//sNZi[[h
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	//eNX`̊蓖 
	glTexImage2D(target, 0, internalFormat, texWidth, texHeight, 0, format, type, vel);
	//eNX`gEk@̎w 
	glTexParameteri(target,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
	glTexParameteri(target,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glBindTexture(target, 0);
}
void setFramebufferPhi()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[0] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[0], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}
void setFramebufferVel()
{
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[1] );
	//textureframebuffer objectɌт
	glFramebufferTexture2DEXT( GL_FRAMEBUFFER_EXT, GL_COLOR_ATTACHMENT0_EXT, target, texID[1], 0 );
	//framebuffer object ̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );
}

void display(void)
{
	//Ԍv
	QueryPerformanceFrequency( &freq );
	QueryPerformanceCounter( &currentTime);
	pTime = (double)((currentTime.QuadPart - lastTime.QuadPart) * 1000000 / freq.QuadPart);
	double dt = pTime / 1000000.0;//[sec]
	elapseTime1 += dt;
	static int fps = 0;
	static int fps0 = 0;
	fps ++;

	static int countStrobo = 0;
	if(elapseTime1 >= 1.0)
	{
		elapseTime1 = 0.0;
		fps0 = fps;
		fps = 0;
	}
	QueryPerformanceCounter( &lastTime);

	float deltaT = deltaT0 / (float)thinningN;
	float Courant;
	if(flagRotation == 1)  Courant = maxSpeed * deltaT / rect.delta.x;
	else Courant = velocity.magnitude() * deltaT / rect.delta.x;
	
	float diff_num = diff_coef * deltaT / (rect.delta.x * rect.delta.x);//gU
	if(flagStart==true && flagFreeze == false)
	{
		//ʂ̍XV
		for(int i = 0; i < thinningN; i++) renewPhi( deltaT, diff_num ); 

		if(flagStep) flagFreeze = true;
		elapseTime2 += deltaT * (float)thinningN;;
	}

	//J[obt@,fvXobt@̃NA
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	resize(win_width, win_height);

	glLoadIdentity();//_ςƂ͂̈ʒuɕKv

	if(cos(M_PI * view.theta /180.0) >= 0.0)//Jp90xޭ޸ِؑ
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, 1.0);
	else
		gluLookAt(view.vPos.x, view.vPos.y, view.vPos.z, view.vCnt.x, view.vCnt.y, view.vCnt.z, 0.0, 0.0, -1.0);

	//ݒ
	glLightfv(GL_LIGHT0, GL_POSITION, lightPos);

	if(flagWireframe == 1)
	{
	  glPolygonMode(GL_FRONT,GL_LINE);
	  glPolygonMode(GL_BACK,GL_POINT);
	}
	else 
		glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

	rendering();
	
	if(flagFloor) glCallList(floor0);//En
	if(flagScaleShow) drawScale(10.0, 10.0, 5.0);
	if(flagCoordShow) drawWorldCoordinates(5.0);
	 
	if(flagParamShow && !flagOrtho) 
	{
		drawParam("framerate=%d[fps]", fps0, 10, 30);
		drawParam("timestep=%1.5f[s]", dt, 200, 30);
		drawParam("elapsetime=%3.3f[s]", elapseTime2, 400, 30);
		drawParam("deltaX=%1.5f[m]", rect.delta.x, 10, 60);
		drawParam("deltaT=%1.5f[s]", deltaT, 150, 60);
		drawParam("Courant=%1.5f", Courant, 300, 60);
		drawParam("diff_num=%1.5f", diff_num, 440, 60);
	}

	//obt@̐؂ւ
	glutSwapBuffers();	
}

void renewPhi(float deltaT, float diff_num)
{
	//framebuffer object0L
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, fbo[0] );
	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//phi[]
	glActiveTexture(GL_TEXTURE1);
	glBindTexture(target, texID[1]);//vel[]
	//VF[_vOL
	glUseProgram(shader_prog1);
	GLint samplerPhiLoc = glGetUniformLocation(shader_prog1, "samplerPhi");
	glUniform1i(samplerPhiLoc, 0);//GL_TEXTURE0Kp
	GLint samplerVelLoc = glGetUniformLocation(shader_prog1, "samplerVel");
	glUniform1i(samplerVelLoc, 1);//GL_TEXTURE1Kp
	GLint texWidthLoc = glGetUniformLocation(shader_prog1, "texWidth");
	glUniform1i(texWidthLoc, texWidth);
	GLint deltaTLoc = glGetUniformLocation(shader_prog1, "deltaT");
	glUniform1f(deltaTLoc, deltaT);
	GLint diffLoc = glGetUniformLocation(shader_prog1, "diff_num");
	glUniform1f(diffLoc, diff_num);
	GLint sizeLoc = glGetUniformLocation(shader_prog1, "size0");
	glUniform1f(sizeLoc, rect.size.x);
	GLint boundaryLoc = glGetUniformLocation(shader_prog1, "boundary");
	glUniform1i(boundaryLoc, boundary);

	drawNumberingPoints();//l͗p̃eNX`\tIuWFNg

	// VF[_vỎ 
	glUseProgram(0);
	glReadPixels(0, 0, texWidth, texHeight, format, type, phi);
	glBindTexture(target, 0);
	//framebuffer object̖
	glBindFramebufferEXT( GL_FRAMEBUFFER_EXT, 0 );

	if(flagConstant)
	{
		int i, j, k;
		float x, y, r;
		for(j = 0; j < texHeight; j++)
			for(i = 0; i < texWidth; i++)
			{
				k = i + j * texWidth;
				//zS̋
				x = (float)i * rect.delta.x - centerInit.x ;
				y = (float)j * rect.delta.y - centerInit.y ;
				if(profile == 0)//Cylinder
				{
					r = sqrt(x * x + y * y);
					if(r < radiusInit) phi[3*k] = 1.0;//ʁixCZxetc.)
				}
				else//Cube
				{
					if(fabs(x) < radiusInit && fabs(y) < radiusInit) phi[3*k] = 1.0;//ʁixCZxetc.)
				}
			}
		setTexturePhi();
		setFramebufferPhi();
	}
}

void drawNumberingPoints()
{
	//r[|[g̃TCYݒ
	glViewport(0, 0, texWidth, texHeight);
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	//es̐ݒ
	gluOrtho2D(0.0, texWidth, 0.0, texHeight);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	//ʂeNX`Ƃē\t邽߂̉zIuWFNg
	glBegin(GL_POINTS);
	for(int j = 0; j < texHeight; j++)
		for(int i = 0; i < texWidth; i++)
	   glVertex2f((float)i, (float)j);//_W2iq_ԍ
	glEnd();
}

void rendering()
{
	glUseProgram(shader_prog2);

	glActiveTexture(GL_TEXTURE0);
	glBindTexture(target, texID[0]);//phi[]

	GLint samplerLoc = glGetUniformLocation(shader_prog2, "samplerPhi");
	glUniform1i(samplerLoc, 0);//GL_TEXTURE0Kp
	GLint texWidthLoc = glGetUniformLocation(shader_prog2, "texWidth");
	glUniform1i(texWidthLoc, texWidth);

	GLint nMeshLoc = glGetUniformLocation(shader_prog2, "nMesh");
	glUniform1i(nMeshLoc, rect.nMesh);
	GLint sizeLoc = glGetUniformLocation(shader_prog2, "size0");
	glUniform1f(sizeLoc, rect.size.x);
	GLint adjustHLoc = glGetUniformLocation(shader_prog2, "adjustH");
	glUniform1f(adjustHLoc, adjustH);
	GLint colorLoc = glGetUniformLocation(shader_prog2, "color");
	glUniform1i(colorLoc, color);

	if(flagWireframe == 0)
		drawGridPlate((float)rect.nMesh, (float)rect.nMesh, rect.nMesh, rect.nMesh);
	else
		drawGridLines((float)rect.nMesh, (float)rect.nMesh, rect.nMesh, rect.nMesh);

	glUseProgram(0);
}

void createFloor()
{
	floor0 = glGenLists(1);
	if(floor0 == 0) {printf("floor  display list mۂł܂!\n"); return;}
	glNewList(floor0, GL_COMPILE);
	glPushMatrix();
	glTranslatef(0.0, 0.0, -0.001);
	drawFloorZ(rect.size.x, rect.size.y, 2, 2);
	glPopMatrix();
	glEndList();
}
